Page MenuHomePhabricator

CX2: Better communicate waiting and application of MT when changed
Closed, ResolvedPublic

Description

The Automatic Translation card (T188247) allows to select between MT services. Currently, changing between services replaces the affected paragraph after some delay. If the delay becomes significant, users may perceive their action had no effect. in addition the change in the paragraph content may not be always noticeable.

In order to communicate better these transitions, the following is proposed:

  • Show the three dot loading placeholder if the change is not immediate. Deciding whether the wait is immediate can be based on the type of action (MT services are expected to take time, while clearing the paragraph or copying the source is expected to be immediate) or defining a short time threshold. The loading placeholder is the same that is used the first time the paragraph is added to the translation.
  • Highlight the resulting paragraph for a second. In order to draw the attention to the paragraph that changed as the result of the user action, the target paragraph affected will be highlighted (using the usual cx-section-highlight) and fading away after a second.
LoadingHighlight

Event Timeline

Pginer-WMF triaged this task as Normal priority.May 31 2018, 10:45 AM
Pginer-WMF created this task.

My plan was to create CXLoadingIndicatorNode similar to CXPlaceholderNode, but I have not yet been able to figure out how to replace the section contents without causing failures everywhere.

My plan was to create CXLoadingIndicatorNode similar to CXPlaceholderNode, but I have not yet been able to figure out how to replace the section contents without causing failures everywhere.

If this becomes too complex, we can try a different approach for the transition:
First, make the paragraph become "disabled" (opacity fades to 50% and becomes not interactive). When the new content is available, it replaces the old one and transitions to enabled with the final highlight.

I recreated the transition in this prototype and the animation below:

https://gerrit.wikimedia.org/r/c/mediawiki/extensions/ContentTranslation/+/442237 Introduces pre and post translate handlers. That might be useful to address this.

As shown in T196988: CX2: Failing to adapt an infobox leaves it loading forever, a graceful failure in case of MT failures is also a requirement. I think the solution for that is not different from the implementation of this ticket.

Vvjjkkii renamed this task from CX2: Better communicate waiting and application of MT when changed to 7wbaaaaaaa.Jul 1 2018, 1:07 AM
Vvjjkkii raised the priority of this task from Normal to High.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed a subscriber: Aklapper.
CommunityTechBot renamed this task from 7wbaaaaaaa to CX2: Better communicate waiting and application of MT when changed.Jul 2 2018, 2:06 AM
CommunityTechBot lowered the priority of this task from High to Normal.
CommunityTechBot updated the task description. (Show Details)
CommunityTechBot added a subscriber: Aklapper.
santhosh claimed this task.Jul 4 2018, 11:49 AM

Change 443823 had a related patch set uploaded (by Santhosh; owner: Santhosh):
[mediawiki/extensions/ContentTranslation@master] WIP: Show progress indication while MT options are changes

https://gerrit.wikimedia.org/r/443823

Change 443823 merged by jenkins-bot:
[mediawiki/extensions/ContentTranslation@master] Show progress indication while MT option changes

https://gerrit.wikimedia.org/r/443823

Petar.petkovic moved this task from In Review to QA on the Language-2018-Apr-June board.
Petar.petkovic moved this task from In Progress to QA on the Language-2018-July-September board.
Petar.petkovic removed a subscriber: gerritbot.
Etonkovidova closed this task as Resolved.Jul 9 2018, 10:32 PM
Etonkovidova added a subscriber: Etonkovidova.

Checked in cx2-testing - the current behavior is according to the mockup.